--- a/drivers/char/generic_serial.c
+++ b/drivers/char/generic_serial.c
@@ -534,7 +534,8 @@ int gs_block_til_ready(void *port_, stru
 	 * until it's done, and then try again.
 	 */
 	if (tty_hung_up_p(filp) || port->flags & ASYNC_CLOSING) {
-		interruptible_sleep_on(&port->close_wait);
+		wait_event_interruptible(port->close_wait,
+			(port->flags & ASYNC_CLOSING) == 0);
 		if (port->flags & ASYNC_HUP_NOTIFY)
 			return -EAGAIN;
 		else
--- a/drivers/char/isicom.c
+++ b/drivers/char/isicom.c
@@ -896,7 +896,8 @@ static int block_til_ready(struct tty_st
 
 	if (tty_hung_up_p(filp) || port->flags & ASYNC_CLOSING) {
 		pr_dbg("block_til_ready: close in progress.\n");
-		interruptible_sleep_on(&port->close_wait);
+		wait_event_interruptible(port->close_wait,
+			(port->flags & ASYNC_CLOSING)==0);
 		if (port->flags & ASYNC_HUP_NOTIFY)
 			return -EAGAIN;
 		else
--- a/drivers/char/istallion.c
+++ b/drivers/char/istallion.c
@@ -1048,7 +1048,8 @@ static int stli_open(struct tty_struct *
  *	for it is done with the same context.
  */
 	if (portp->flags & ASYNC_CLOSING) {
-		interruptible_sleep_on(&portp->close_wait);
+		wait_event_interruptible(portp->close_wait,
+			(portp->flags & ASYNC_CLOSING) == 0);
 		if (portp->flags & ASYNC_HUP_NOTIFY)
 			return(-EAGAIN);
 		return(-ERESTARTSYS);
@@ -1088,7 +1089,8 @@ static int stli_open(struct tty_struct *
  *	for it is done with the same context.
  */
 	if (portp->flags & ASYNC_CLOSING) {
-		interruptible_sleep_on(&portp->close_wait);
+		wait_event_interruptible(portp->close_wait,
+			(portp->flags & ASYNC_CLOSING) == 0);
 		if (portp->flags & ASYNC_HUP_NOTIFY)
 			return(-EAGAIN);
 		return(-ERESTARTSYS);
@@ -2506,7 +2508,7 @@ static int stli_portinfo(stlibrd_t *brdp
 	sp = pos;
 	sp += sprintf(sp, "%d: uart:%s ", portnr, uart);
 
-	if ((brdp->state & BST_STARTED) && (rc >= 0)) {
+	if (capable(CAP_SYS_RAWIO) && (brdp->state & BST_STARTED) && (rc >= 0)) {
 		sp += sprintf(sp, "tx:%d rx:%d", (int) stli_comstats.txtotal,
 			(int) stli_comstats.rxtotal);
 
--- a/drivers/char/keyboard.c
+++ b/drivers/char/keyboard.c
@@ -975,7 +975,7 @@ static int emulate_raw(struct vc_data *v
 			put_queue(vc, 0x1d | up_flag);
 			put_queue(vc, 0x45 | up_flag);
 			return 0;
-		case KEY_HANGUEL:
+		case KEY_HANGEUL:
 			if (!up_flag) put_queue(vc, 0xf1);
 			return 0;
 		case KEY_HANJA:
--- a/drivers/char/moxa.c
+++ b/drivers/char/moxa.c
@@ -1003,8 +1003,8 @@ static int block_till_ready(struct tty_s
 	 * until it's done, and then try again.
 	 */
 	if (tty_hung_up_p(filp) || (ch->asyncflags & ASYNC_CLOSING)) {
-		if (ch->asyncflags & ASYNC_CLOSING)
-			interruptible_sleep_on(&ch->close_wait);
+		wait_event_interruptible(ch->close_wait,
+			(ch->asyncflags & ASYNC_CLOSING)==0);
 #ifdef SERIAL_DO_RESTART
 		if (ch->asyncflags & ASYNC_HUP_NOTIFY)
 			return (-EAGAIN);
--- a/drivers/char/pcmcia/synclink_cs.c
+++ b/drivers/char/pcmcia/synclink_cs.c
@@ -2759,8 +2759,8 @@ static int mgslpc_open(struct tty_struct
 
 	/* If port is closing, signal caller to try again */
 	if (tty_hung_up_p(filp) || info->flags & ASYNC_CLOSING){
-		if (info->flags & ASYNC_CLOSING)
-			interruptible_sleep_on(&info->close_wait);
+		wait_event_interruptible(info->close_wait,
+			(info->flags & ASYNC_CLOSING)==0);
 		retval = ((info->flags & ASYNC_HUP_NOTIFY) ?
 			-EAGAIN : -ERESTARTSYS);
 		goto cleanup;
@@ -2821,6 +2821,11 @@ static inline int line_info(char *buf, M
 	ret = sprintf(buf, "%s:io:%04X irq:%d",
 		      info->device_name, info->io_base, info->irq_level);
 
+	if (!capable(CAP_SYS_RAWIO)) {
+		strcat(buf, "\n");
+		return ret + 1;
+	}
+
 	/* output current serial signal states */
 	spin_lock_irqsave(&info->lock,flags);
  	get_signals(info);
@@ -4042,8 +4047,8 @@ BOOLEAN irq_test(MGSLPC_INFO *info)
 
 	spin_unlock_irqrestore(&info->lock,flags);
 
-	end_time=100;
-	while(end_time-- && !info->irq_occurred) {
+	end_time = jiffies + msecs_to_jiffies(1000);
+	while (time_before(jiffies, end_time) && !info->irq_occurred) {
 		msleep_interruptible(10);
 	}
 	
--- a/drivers/char/riscom8.c
+++ b/drivers/char/riscom8.c
@@ -941,7 +941,8 @@ static int block_til_ready(struct tty_st
 	 * until it's done, and then try again.
 	 */
 	if (tty_hung_up_p(filp) || port->flags & ASYNC_CLOSING) {
-		interruptible_sleep_on(&port->close_wait);
+		wait_event_interruptible(port->close_wait,
+			(port->flags & ASYNC_CLOSING) == 0);
 		if (port->flags & ASYNC_HUP_NOTIFY)
 			return -EAGAIN;
 		else
@@ -1743,10 +1744,10 @@ static int iobase;
 static int iobase1;
 static int iobase2;
 static int iobase3;
-MODULE_PARM(iobase, "i");
-MODULE_PARM(iobase1, "i");
-MODULE_PARM(iobase2, "i");
-MODULE_PARM(iobase3, "i");
+module_param(iobase, int, 0);
+module_param(iobase1, int, 0);
+module_param(iobase2, int, 0);
+module_param(iobase3, int, 0);
 
 MODULE_LICENSE("GPL");
 #endif /* MODULE */
--- a/drivers/char/rocket.c
+++ b/drivers/char/rocket.c
@@ -898,7 +898,8 @@ static int block_til_ready(struct tty_st
 	if (tty_hung_up_p(filp))
 		return ((info->flags & ROCKET_HUP_NOTIFY) ? -EAGAIN : -ERESTARTSYS);
 	if (info->flags & ROCKET_CLOSING) {
-		interruptible_sleep_on(&info->close_wait);
+		wait_event_interruptible(info->close_wait,
+			(info->flags & ROCKET_CLOSING)==0);
 		return ((info->flags & ROCKET_HUP_NOTIFY) ? -EAGAIN : -ERESTARTSYS);
 	}
 
@@ -1003,7 +1004,8 @@ static int rp_open(struct tty_struct *tt
 		return -ENOMEM;
 
 	if (info->flags & ROCKET_CLOSING) {
-		interruptible_sleep_on(&info->close_wait);
+		wait_event_interruptible(info->close_wait,
+			(info->flags & ROCKET_CLOSING)==0);
 		free_page(page);
 		return ((info->flags & ROCKET_HUP_NOTIFY) ? -EAGAIN : -ERESTARTSYS);
 	}
--- a/drivers/char/serial167.c
+++ b/drivers/char/serial167.c
@@ -1851,7 +1851,8 @@ block_til_ready(struct tty_struct *tty, 
      * until it's done, and then try again.
      */
     if (info->flags & ASYNC_CLOSING) {
-	interruptible_sleep_on(&info->close_wait);
+	wait_event_interruptible(info->close_wait,
+		(info->flags & ASYNC_CLOSING) == 0);
 	if (info->flags & ASYNC_HUP_NOTIFY){
 	    return -EAGAIN;
 	}else{
--- a/drivers/char/sonypi.c
+++ b/drivers/char/sonypi.c
@@ -724,7 +724,8 @@ static void sonypi_camera_off(void)
 /* Turns the camera on */
 static void sonypi_camera_on(void)
 {
-	int i, j;
+	int j;
+	unsigned long end_time;
 
 	if (sonypi_device.camera_power)
 		return;
@@ -735,12 +736,13 @@ static void sonypi_camera_on(void)
 			msleep(10);
 		sonypi_call1(0x93);
 
-		for (i = 400; i > 0; i--) {
+		end_time = jiffies + msecs_to_jiffies(4000);
+		while (time_before(jiffies, end_time)) {
 			if (sonypi_camera_ready())
 				break;
 			msleep(10);
 		}
-		if (i)
+		if (time_before(jiffies, end_time))
 			break;
 	}
 
--- a/drivers/char/specialix.c
+++ b/drivers/char/specialix.c
@@ -1404,7 +1404,8 @@ static int block_til_ready(struct tty_st
 	 * until it's done, and then try again.
 	 */
 	if (tty_hung_up_p(filp) || port->flags & ASYNC_CLOSING) {
-		interruptible_sleep_on(&port->close_wait);
+		wait_event_interruptible(port->close_wait,
+			(port->flags & ASYNC_CLOSING)==0);
 		if (port->flags & ASYNC_HUP_NOTIFY) {
 			func_exit();
 			return -EAGAIN;
--- a/drivers/char/stallion.c
+++ b/drivers/char/stallion.c
@@ -1041,7 +1041,8 @@ static int stl_open(struct tty_struct *t
  *	for it is done with the same context.
  */
 	if (portp->flags & ASYNC_CLOSING) {
-		interruptible_sleep_on(&portp->close_wait);
+		wait_event_interruptible(portp->close_wait,
+			(portp->flags & ASYNC_CLOSING) == 0);
 		if (portp->flags & ASYNC_HUP_NOTIFY)
 			return -EAGAIN;
 		return -ERESTARTSYS;
@@ -1843,28 +1844,37 @@ static int stl_portinfo(stlport_t *portp
 	int	sigs, cnt;
 
 	sp = pos;
-	sp += sprintf(sp, "%d: uart:%s tx:%d rx:%d",
-		portnr, (portp->hwid == 1) ? "SC26198" : "CD1400",
-		(int) portp->stats.txtotal, (int) portp->stats.rxtotal);
-
-	if (portp->stats.rxframing)
-		sp += sprintf(sp, " fe:%d", (int) portp->stats.rxframing);
-	if (portp->stats.rxparity)
-		sp += sprintf(sp, " pe:%d", (int) portp->stats.rxparity);
-	if (portp->stats.rxbreaks)
-		sp += sprintf(sp, " brk:%d", (int) portp->stats.rxbreaks);
-	if (portp->stats.rxoverrun)
-		sp += sprintf(sp, " oe:%d", (int) portp->stats.rxoverrun);
-
-	sigs = stl_getsignals(portp);
-	cnt = sprintf(sp, "%s%s%s%s%s ",
-		(sigs & TIOCM_RTS) ? "|RTS" : "",
-		(sigs & TIOCM_CTS) ? "|CTS" : "",
-		(sigs & TIOCM_DTR) ? "|DTR" : "",
-		(sigs & TIOCM_CD) ? "|DCD" : "",
-		(sigs & TIOCM_DSR) ? "|DSR" : "");
-	*sp = ' ';
-	sp += cnt;
+	sp += sprintf(sp, "%d: uart:%s",
+		portnr, (portp->hwid == 1) ? "SC26198" : "CD1400");
+
+	if (capable(CAP_SYS_RAWIO)) {
+		sp += sprintf(sp, " tx:%d rx:%d",
+			(int) portp->stats.txtotal,
+			(int) portp->stats.rxtotal);
+
+		if (portp->stats.rxframing)
+			sp += sprintf(sp, " fe:%d",
+					(int) portp->stats.rxframing);
+		if (portp->stats.rxparity)
+			sp += sprintf(sp, " pe:%d",
+					(int) portp->stats.rxparity);
+		if (portp->stats.rxbreaks)
+			sp += sprintf(sp, " brk:%d",
+					(int) portp->stats.rxbreaks);
+		if (portp->stats.rxoverrun)
+			sp += sprintf(sp, " oe:%d",
+					(int) portp->stats.rxoverrun);
+
+		sigs = stl_getsignals(portp);
+		cnt = sprintf(sp, "%s%s%s%s%s ",
+			(sigs & TIOCM_RTS) ? "|RTS" : "",
+			(sigs & TIOCM_CTS) ? "|CTS" : "",
+			(sigs & TIOCM_DTR) ? "|DTR" : "",
+			(sigs & TIOCM_CD) ? "|DCD" : "",
+			(sigs & TIOCM_DSR) ? "|DSR" : "");
+		*sp = ' ';
+		sp += cnt;
+	}
 
 	for (cnt = (sp - pos); (cnt < (MAXLINE - 1)); cnt++)
 		*sp++ = ' ';
--- a/drivers/char/sx.c
+++ b/drivers/char/sx.c
@@ -1510,8 +1510,7 @@ static int sx_open  (struct tty_struct *
 static void sx_close (void *ptr)
 {
 	struct sx_port *port = ptr; 
-	/* Give the port 5 seconds to close down. */
-	int to = 5 * HZ; 
+	unsigned long start_time, end_time;
 
 	func_enter ();
 
@@ -1519,9 +1518,13 @@ static void sx_close (void *ptr)
 	sx_reconfigure_port(port);	
 	sx_send_command (port, HS_CLOSE, 0, 0);
 
-	while (to-- && (sx_read_channel_byte (port, hi_hstat) != HS_IDLE_CLOSED))
+	/* Give the port 5 seconds to close down. */
+	start_time = jiffies;
+	end_time = start_time + msecs_to_jiffies(5000);
+	while (time_before(jiffies, end_time) && (sx_read_channel_byte (port, hi_hstat) != HS_IDLE_CLOSED))
 		if (msleep_interruptible(10))
 			break;
+	end_time = jiffies;
 	if (sx_read_channel_byte (port, hi_hstat) != HS_IDLE_CLOSED) {
 		if (sx_send_command (port, HS_FORCE_CLOSED, -1, HS_IDLE_CLOSED) != 1) {
 			printk (KERN_ERR 
@@ -1530,8 +1533,8 @@ static void sx_close (void *ptr)
 			sx_dprintk (SX_DEBUG_CLOSE, "sent the force_close command.\n");
 	}
 
-	sx_dprintk (SX_DEBUG_CLOSE, "waited %d jiffies for close. count=%d\n", 
-	            5 * HZ - to - 1, port->gs.count);
+	sx_dprintk (SX_DEBUG_CLOSE, "waited %ld jiffies for close. count=%d\n", 
+	            end_time - start_time, port->gs.count);
 
 	if(port->gs.count) {
 		sx_dprintk(SX_DEBUG_CLOSE, "WARNING port count:%d\n", port->gs.count);
--- a/drivers/char/synclink.c
+++ b/drivers/char/synclink.c
@@ -3465,8 +3465,8 @@ static int mgsl_open(struct tty_struct *
 
 	/* If port is closing, signal caller to try again */
 	if (tty_hung_up_p(filp) || info->flags & ASYNC_CLOSING){
-		if (info->flags & ASYNC_CLOSING)
-			interruptible_sleep_on(&info->close_wait);
+		wait_event_interruptible(info->close_wait,
+			(info->flags & ASYNC_CLOSING)==0);
 		retval = ((info->flags & ASYNC_HUP_NOTIFY) ?
 			-EAGAIN : -ERESTARTSYS);
 		goto cleanup;
@@ -3547,6 +3547,11 @@ static inline int line_info(char *buf, s
 			info->irq_level, info->dma_level);
 	}
 
+	if (!capable(CAP_SYS_RAWIO)) {
+		strcat(buf, "\n");
+		return ret + 1;
+	}
+
 	/* output current serial signal states */
 	spin_lock_irqsave(&info->irq_spinlock,flags);
  	usc_get_serial_signals(info);
@@ -7100,8 +7105,8 @@ static BOOLEAN mgsl_register_test( struc
  */
 static BOOLEAN mgsl_irq_test( struct mgsl_struct *info )
 {
-	unsigned long EndTime;
 	unsigned long flags;
+	unsigned long end_time;
 
 	spin_lock_irqsave(&info->irq_spinlock,flags);
 	usc_reset(info);
@@ -7128,8 +7133,8 @@ static BOOLEAN mgsl_irq_test( struct mgs
 
 	spin_unlock_irqrestore(&info->irq_spinlock,flags);
 
-	EndTime=100;
-	while( EndTime-- && !info->irq_occurred ) {
+	end_time = jiffies + msecs_to_jiffies(1000);
+	while (time_before(jiffies, end_time) && !info->irq_occurred) {
 		msleep_interruptible(10);
 	}
 	
--- a/drivers/char/synclink_gt.c
+++ b/drivers/char/synclink_gt.c
@@ -48,7 +48,6 @@
 
 #include <linux/config.h>
 #include <linux/module.h>
-#include <linux/version.h>
 #include <linux/errno.h>
 #include <linux/signal.h>
 #include <linux/sched.h>
--- a/drivers/char/synclinkmp.c
+++ b/drivers/char/synclinkmp.c
@@ -757,8 +757,8 @@ static int open(struct tty_struct *tty, 
 
 	/* If port is closing, signal caller to try again */
 	if (tty_hung_up_p(filp) || info->flags & ASYNC_CLOSING){
-		if (info->flags & ASYNC_CLOSING)
-			interruptible_sleep_on(&info->close_wait);
+		wait_event_interruptible(info->close_wait,
+			(info->flags & ASYNC_CLOSING) == 0);
 		retval = ((info->flags & ASYNC_HUP_NOTIFY) ?
 			-EAGAIN : -ERESTARTSYS);
 		goto cleanup;
@@ -1422,6 +1422,10 @@ static inline int line_info(char *buf, S
 		info->irq_level,
 		info->max_frame_size );
 
+	if (!capable(CAP_SYS_RAWIO)) {
+		return ret;
+	}
+
 	/* output current serial signal states */
 	spin_lock_irqsave(&info->lock,flags);
  	get_signals(info);
@@ -5128,8 +5132,8 @@ int register_test(SLMP_INFO *info)
 
 int irq_test(SLMP_INFO *info)
 {
-	unsigned long timeout;
 	unsigned long flags;
+	unsigned long end_time;
 
 	unsigned char timer = (info->port_num & 1) ? TIMER2 : TIMER0;
 
@@ -5163,8 +5167,8 @@ int irq_test(SLMP_INFO *info)
 
 	spin_unlock_irqrestore(&info->lock,flags);
 
-	timeout=100;
-	while( timeout-- && !info->irq_occurred ) {
+	end_time = jiffies + msecs_to_jiffies(1000);
+	while (time_before(jiffies, end_time) && !info->irq_occurred) {
 		msleep_interruptible(10);
 	}
 
--- a/drivers/char/tpm/tpm_infineon.c
+++ b/drivers/char/tpm/tpm_infineon.c
@@ -135,15 +135,17 @@ static int empty_fifo(struct tpm_chip *c
 static int wait(struct tpm_chip *chip, int wait_for_bit)
 {
 	int status;
-	int i;
-	for (i = 0; i < TPM_MAX_TRIES; i++) {
+	unsigned long end_time;
+
+	end_time = jiffies + msecs_to_jiffies(TPM_MAX_TRIES * TPM_MSLEEP_TIME);
+	while (time_before(jiffies, end_time)) {
 		status = inb(chip->vendor->base + STAT);
 		/* check the status-register if wait_for_bit is set */
 		if (status & 1 << wait_for_bit)
 			break;
 		msleep(TPM_MSLEEP_TIME);
 	}
-	if (i == TPM_MAX_TRIES) {	/* timeout occurs */
+	if (time_after_eq(jiffies, end_time)) {	/* timeout occurs */
 		if (wait_for_bit == STAT_XFE)
 			dev_err(chip->dev, "Timeout in wait(STAT_XFE)\n");
 		if (wait_for_bit == STAT_RDA)
--- a/drivers/char/watchdog/wdt285.c
+++ b/drivers/char/watchdog/wdt285.c
@@ -204,11 +204,11 @@ static int __init footbridge_watchdog_in
 	if (retval < 0)
 		return retval;
 
-	printk("Footbridge Watchdog Timer: 0.01, timer margin: %d sec\n",
+	printk(KERN_INFO "Footbridge Watchdog Timer: 0.01, timer margin: %d sec\n",
 	       soft_margin);
 
 	if (machine_is_cats())
-		printk("Warning: Watchdog reset may not work on this machine.\n");
+		printk(KERN_WARNING "Warning: Watchdog reset may not work on this machine.\n");
 	return 0;
 }
 
--- a/drivers/i2c/algos/i2c-algo-pca.c
+++ b/drivers/i2c/algos/i2c-algo-pca.c
@@ -187,9 +187,10 @@ static int pca_xfer(struct i2c_adapter *
 	int numbytes = 0;
 	int state;
 	int ret;
-	int timeout = 100;
+	unsigned long end_time;
 
-	while ((state = pca_status(adap)) != 0xf8 && timeout--) {
+	end_time = jiffies + msecs_to_jiffies(1000);
+	while ((state = pca_status(adap)) != 0xf8 && time_before(jiffies, end_time)) {
 		msleep(10);
 	}
 	if (state != 0xf8) {
--- a/drivers/i2c/busses/i2c-ali1535.c
+++ b/drivers/i2c/busses/i2c-ali1535.c
@@ -210,7 +210,7 @@ static int ali1535_transaction(struct i2
 {
 	int temp;
 	int result = 0;
-	int timeout = 0;
+	unsigned long end_time;
 
 	dev_dbg(&adap->dev, "Transaction (pre): STS=%02x, TYP=%02x, "
 		"CMD=%02x, ADD=%02x, DAT0=%02x, DAT1=%02x\n",
@@ -275,15 +275,15 @@ static int ali1535_transaction(struct i2
 	outb_p(0xFF, SMBHSTPORT);
 
 	/* We will always wait for a fraction of a second! */
-	timeout = 0;
+	end_time = jiffies + msecs_to_jiffies(MAX_TIMEOUT);
 	do {
 		msleep(1);
 		temp = inb_p(SMBHSTSTS);
 	} while (((temp & ALI1535_STS_BUSY) && !(temp & ALI1535_STS_IDLE))
-		 && (timeout++ < MAX_TIMEOUT));
+		 && time_before(jiffies, end_time));
 
 	/* If the SMBus is still busy, we give up */
-	if (timeout >= MAX_TIMEOUT) {
+	if (time_after_eq(jiffies, end_time)) {
 		result = -1;
 		dev_err(&adap->dev, "SMBus Timeout!\n");
 	}
@@ -342,19 +342,19 @@ static s32 ali1535_access(struct i2c_ada
 {
 	int i, len;
 	int temp;
-	int timeout;
 	s32 result = 0;
+	unsigned long end_time;
 
 	down(&i2c_ali1535_sem);
 	/* make sure SMBus is idle */
 	temp = inb_p(SMBHSTSTS);
-	for (timeout = 0;
-	     (timeout < MAX_TIMEOUT) && !(temp & ALI1535_STS_IDLE);
-	     timeout++) {
+
+	end_time = jiffies + msecs_to_jiffies(MAX_TIMEOUT);
+	while (time_before(jiffies, end_time) && !(temp & ALI1535_STS_IDLE)) {
 		msleep(1);
 		temp = inb_p(SMBHSTSTS);
 	}
-	if (timeout >= MAX_TIMEOUT)
+	if (time_after_eq(jiffies, end_time))
 		dev_warn(&adap->dev, "Idle wait Timeout! STS=0x%02x\n", temp);
 
 	/* clear status register (clear-on-write) */
--- a/drivers/i2c/busses/i2c-ali1563.c
+++ b/drivers/i2c/busses/i2c-ali1563.c
@@ -66,7 +66,8 @@ static unsigned short ali1563_smba;
 static int ali1563_transaction(struct i2c_adapter * a, int size)
 {
 	u32 data;
-	int timeout;
+	unsigned long end_time;
+	int timeout_reached;
 
 	dev_dbg(&a->dev, "Transaction (pre): STS=%02x, CNTL1=%02x, "
 		"CNTL2=%02x, CMD=%02x, ADD=%02x, DAT0=%02x, DAT1=%02x\n",
@@ -84,10 +85,11 @@ static int ali1563_transaction(struct i2
 	}
 	outb_p(inb_p(SMB_HST_CNTL2) | HST_CNTL2_START, SMB_HST_CNTL2);
 
-	timeout = ALI1563_MAX_TIMEOUT;
+	end_time = jiffies + msecs_to_jiffies(ALI1563_MAX_TIMEOUT);
 	do
 		msleep(1);
-	while (((data = inb_p(SMB_HST_STS)) & HST_STS_BUSY) && --timeout);
+	while (((data = inb_p(SMB_HST_STS)) & HST_STS_BUSY) && time_before(jiffies, end_time));
+	timeout_reached = time_after_eq(jiffies, end_time);
 
 	dev_dbg(&a->dev, "Transaction (post): STS=%02x, CNTL1=%02x, "
 		"CNTL2=%02x, CMD=%02x, ADD=%02x, DAT0=%02x, DAT1=%02x\n",
@@ -95,10 +97,10 @@ static int ali1563_transaction(struct i2
 		inb_p(SMB_HST_CMD), inb_p(SMB_HST_ADD), inb_p(SMB_HST_DAT0),
 		inb_p(SMB_HST_DAT1));
 
-	if (timeout && !(data & HST_STS_BAD))
+	if (timeout_reached && !(data & HST_STS_BAD))
 		return 0;
 
-	if (!timeout) {
+	if (!timeout_reached) {
 		dev_err(&a->dev, "Timeout - Trying to KILL transaction!\n");
 		/* Issue 'kill' to host controller */
 		outb_p(HST_CNTL2_KILL,SMB_HST_CNTL2);
@@ -128,7 +130,8 @@ static int ali1563_transaction(struct i2
 static int ali1563_block_start(struct i2c_adapter * a)
 {
 	u32 data;
-	int timeout;
+	unsigned long end_time;
+	int timeout_reached;
 
 	dev_dbg(&a->dev, "Block (pre): STS=%02x, CNTL1=%02x, "
 		"CNTL2=%02x, CMD=%02x, ADD=%02x, DAT0=%02x, DAT1=%02x\n",
@@ -151,10 +154,11 @@ static int ali1563_block_start(struct i2
 	/* Start transaction and wait for byte-ready bit to be set */
 	outb_p(inb_p(SMB_HST_CNTL2) | HST_CNTL2_START, SMB_HST_CNTL2);
 
-	timeout = ALI1563_MAX_TIMEOUT;
+	end_time = jiffies + msecs_to_jiffies(ALI1563_MAX_TIMEOUT);
 	do
 		msleep(1);
-	while (!((data = inb_p(SMB_HST_STS)) & HST_STS_DONE) && --timeout);
+	while (!((data = inb_p(SMB_HST_STS)) & HST_STS_DONE) && time_before(jiffies, end_time));
+	timeout_reached = time_after_eq(jiffies, end_time);
 
 	dev_dbg(&a->dev, "Block (post): STS=%02x, CNTL1=%02x, "
 		"CNTL2=%02x, CMD=%02x, ADD=%02x, DAT0=%02x, DAT1=%02x\n",
@@ -162,10 +166,10 @@ static int ali1563_block_start(struct i2
 		inb_p(SMB_HST_CMD), inb_p(SMB_HST_ADD), inb_p(SMB_HST_DAT0),
 		inb_p(SMB_HST_DAT1));
 
-	if (timeout && !(data & HST_STS_BAD))
+	if (timeout_reached && !(data & HST_STS_BAD))
 		return 0;
 	dev_err(&a->dev, "SMBus Error: %s%s%s%s%s\n",
-		timeout ? "Timeout " : "",
+		timeout_reached ? "Timeout " : "",
 		data & HST_STS_FAIL ? "Transaction Failed " : "",
 		data & HST_STS_BUSERR ? "No response or Bus Collision " : "",
 		data & HST_STS_DEVERR ? "Device Error " : "",
--- a/drivers/i2c/busses/i2c-ali15x3.c
+++ b/drivers/i2c/busses/i2c-ali15x3.c
@@ -231,7 +231,7 @@ static int ali15x3_transaction(struct i2
 {
 	int temp;
 	int result = 0;
-	int timeout = 0;
+	unsigned long end_time;
 
 	dev_dbg(&adap->dev, "Transaction (pre): STS=%02x, CNT=%02x, CMD=%02x, "
 		"ADD=%02x, DAT0=%02x, DAT1=%02x\n", inb_p(SMBHSTSTS),
@@ -296,15 +296,15 @@ static int ali15x3_transaction(struct i2
 	outb_p(0xFF, SMBHSTSTART);
 
 	/* We will always wait for a fraction of a second! */
-	timeout = 0;
+	end_time = jiffies + msecs_to_jiffies(MAX_TIMEOUT);
 	do {
 		msleep(1);
 		temp = inb_p(SMBHSTSTS);
 	} while ((!(temp & (ALI15X3_STS_ERR | ALI15X3_STS_DONE)))
-		 && (timeout++ < MAX_TIMEOUT));
+		 && time_before(jiffies, end_time));
 
 	/* If the SMBus is still busy, we give up */
-	if (timeout >= MAX_TIMEOUT) {
+	if (time_after_eq(jiffies, end_time)) {
 		result = -1;
 		dev_err(&adap->dev, "SMBus Timeout!\n");
 	}
@@ -346,19 +346,19 @@ static s32 ali15x3_access(struct i2c_ada
 {
 	int i, len;
 	int temp;
-	int timeout;
+	unsigned long end_time;
 
 	/* clear all the bits (clear-on-write) */
 	outb_p(0xFF, SMBHSTSTS);
 	/* make sure SMBus is idle */
 	temp = inb_p(SMBHSTSTS);
-	for (timeout = 0;
-	     (timeout < MAX_TIMEOUT) && !(temp & ALI15X3_STS_IDLE);
-	     timeout++) {
+
+	end_time = jiffies + msecs_to_jiffies(MAX_TIMEOUT);
+	while (time_before(jiffies, end_time) && !(temp & ALI15X3_STS_IDLE)) {
 		msleep(1);
 		temp = inb_p(SMBHSTSTS);
 	}
-	if (timeout >= MAX_TIMEOUT) {
+	if (time_after_eq(jiffies, end_time)) {
 		dev_err(&adap->dev, "Idle wait Timeout! STS=0x%02x\n", temp);
 	}
 
--- a/drivers/i2c/busses/i2c-amd756.c
+++ b/drivers/i2c/busses/i2c-amd756.c
@@ -113,7 +113,7 @@ static int amd756_transaction(struct i2c
 {
 	int temp;
 	int result = 0;
-	int timeout = 0;
+	unsigned long end_time;
 
 	dev_dbg(&adap->dev, "Transaction (pre): GS=%04x, GE=%04x, ADD=%04x, "
 		"DAT=%04x\n", inw_p(SMB_GLOBAL_STATUS),
@@ -123,30 +123,32 @@ static int amd756_transaction(struct i2c
 	/* Make sure the SMBus host is ready to start transmitting */
 	if ((temp = inw_p(SMB_GLOBAL_STATUS)) & (GS_HST_STS | GS_SMB_STS)) {
 		dev_dbg(&adap->dev, "SMBus busy (%04x). Waiting...\n", temp);
+
+		end_time = jiffies + msecs_to_jiffies(MAX_TIMEOUT);
 		do {
 			msleep(1);
 			temp = inw_p(SMB_GLOBAL_STATUS);
 		} while ((temp & (GS_HST_STS | GS_SMB_STS)) &&
-		         (timeout++ < MAX_TIMEOUT));
+		         time_before(jiffies, end_time));
 		/* If the SMBus is still busy, we give up */
-		if (timeout >= MAX_TIMEOUT) {
+		if (time_after_eq(jiffies, end_time)) {
 			dev_dbg(&adap->dev, "Busy wait timeout (%04x)\n", temp);
 			goto abort;
 		}
-		timeout = 0;
 	}
 
 	/* start the transaction by setting the start bit */
 	outw_p(inw(SMB_GLOBAL_ENABLE) | GE_HOST_STC, SMB_GLOBAL_ENABLE);
 
 	/* We will always wait for a fraction of a second! */
+	end_time = jiffies + msecs_to_jiffies(MAX_TIMEOUT);
 	do {
 		msleep(1);
 		temp = inw_p(SMB_GLOBAL_STATUS);
-	} while ((temp & GS_HST_STS) && (timeout++ < MAX_TIMEOUT));
+	} while ((temp & GS_HST_STS) && time_before(jiffies, end_time));
 
 	/* If the SMBus is still busy, we give up */
-	if (timeout >= MAX_TIMEOUT) {
+	if (time_after_eq(jiffies, end_time)) {
 		dev_dbg(&adap->dev, "Completion timeout!\n");
 		goto abort;
 	}
--- a/drivers/i2c/busses/i2c-i801.c
+++ b/drivers/i2c/busses/i2c-i801.c
@@ -181,7 +181,7 @@ static int i801_transaction(void)
 {
 	int temp;
 	int result = 0;
-	int timeout = 0;
+	unsigned long end_time;
 
 	dev_dbg(&I801_dev->dev, "Transaction (pre): CNT=%02x, CMD=%02x, "
 		"ADD=%02x, DAT0=%02x, DAT1=%02x\n", inb_p(SMBHSTCNT),
@@ -205,13 +205,14 @@ static int i801_transaction(void)
 	outb_p(inb(SMBHSTCNT) | I801_START, SMBHSTCNT);
 
 	/* We will always wait for a fraction of a second! */
+	end_time = jiffies + msecs_to_jiffies(MAX_TIMEOUT);
 	do {
 		msleep(1);
 		temp = inb_p(SMBHSTSTS);
-	} while ((temp & 0x01) && (timeout++ < MAX_TIMEOUT));
+	} while ((temp & 0x01) && time_before(jiffies, end_time));
 
 	/* If the SMBus is still busy, we give up */
-	if (timeout >= MAX_TIMEOUT) {
+	if (time_after_eq(jiffies, end_time)) {
 		dev_dbg(&I801_dev->dev, "SMBus Timeout!\n");
 		result = -1;
 	}
@@ -255,8 +256,8 @@ static int i801_block_transaction(union 
 	int smbcmd;
 	int temp;
 	int result = 0;
-	int timeout;
 	unsigned char hostc, errmask;
+	unsigned long end_time;
 
 	if (command == I2C_SMBUS_I2C_BLOCK_DATA) {
 		if (read_write == I2C_SMBUS_WRITE) {
@@ -331,16 +332,15 @@ static int i801_block_transaction(union 
 			outb_p(inb(SMBHSTCNT) | I801_START, SMBHSTCNT);
 
 		/* We will always wait for a fraction of a second! */
-		timeout = 0;
+		end_time = jiffies + msecs_to_jiffies(MAX_TIMEOUT);
 		do {
 			temp = inb_p(SMBHSTSTS);
 			msleep(1);
-		}
-		    while ((!(temp & 0x80))
-			   && (timeout++ < MAX_TIMEOUT));
+		} while ((!(temp & 0x80))
+			   && time_before(jiffies, end_time));
 
 		/* If the SMBus is still busy, we give up */
-		if (timeout >= MAX_TIMEOUT) {
+		if (time_after_eq(jiffies, end_time)) {
 			result = -1;
 			dev_dbg(&I801_dev->dev, "SMBus Timeout!\n");
 		}
@@ -390,14 +390,14 @@ static int i801_block_transaction(union 
 
 	if (hwpec) {
 		/* wait for INTR bit as advised by Intel */
-		timeout = 0;
+		end_time = jiffies + msecs_to_jiffies(MAX_TIMEOUT);
 		do {
 			temp = inb_p(SMBHSTSTS);
 			msleep(1);
 		} while ((!(temp & 0x02))
-			   && (timeout++ < MAX_TIMEOUT));
+			   && time_before(jiffies, end_time));
 
-		if (timeout >= MAX_TIMEOUT) {
+		if (time_after_eq(jiffies, end_time)) {
 			dev_dbg(&I801_dev->dev, "PEC Timeout!\n");
 		}
 		outb_p(temp, SMBHSTSTS); 
--- a/drivers/i2c/busses/i2c-piix4.c
+++ b/drivers/i2c/busses/i2c-piix4.c
@@ -234,7 +234,7 @@ static int piix4_transaction(void)
 {
 	int temp;
 	int result = 0;
-	int timeout = 0;
+	unsigned long end_time;
 
 	dev_dbg(&piix4_adapter.dev, "Transaction (pre): CNT=%02x, CMD=%02x, "
 		"ADD=%02x, DAT0=%02x, DAT1=%02x\n", inb_p(SMBHSTCNT),
@@ -258,13 +258,14 @@ static int piix4_transaction(void)
 	outb_p(inb(SMBHSTCNT) | 0x040, SMBHSTCNT);
 
 	/* We will always wait for a fraction of a second! (See PIIX4 docs errata) */
+	end_time = jiffies + msecs_to_jiffies(MAX_TIMEOUT);
 	do {
 		msleep(1);
 		temp = inb_p(SMBHSTSTS);
-	} while ((temp & 0x01) && (timeout++ < MAX_TIMEOUT));
+	} while ((temp & 0x01) && time_before(jiffies, end_time));
 
 	/* If the SMBus is still busy, we give up */
-	if (timeout >= MAX_TIMEOUT) {
+	if (time_after_eq(jiffies, end_time)) {
 		dev_err(&piix4_adapter.dev, "SMBus Timeout!\n");
 		result = -1;
 	}
--- a/drivers/i2c/busses/i2c-pxa.c
+++ b/drivers/i2c/busses/i2c-pxa.c
@@ -191,20 +191,23 @@ static void i2c_pxa_abort(struct pxa_i2c
 
 static int i2c_pxa_wait_bus_not_busy(struct pxa_i2c *i2c)
 {
-	int timeout = DEF_TIMEOUT;
+	int timeout_reached;
+	unsigned long end_time;
 
-	while (timeout-- && ISR & (ISR_IBB | ISR_UB)) {
+	end_time = jiffies + msecs_to_jiffies(DEF_TIMEOUT * 2);
+	while (time_before(jiffies, end_time) && ISR & (ISR_IBB | ISR_UB)) {
 		if ((ISR & ISR_SAD) != 0)
-			timeout += 4;
+			end_time += msecs_to_jiffies(8);
 
 		msleep(2);
 		show_state(i2c);
 	}
+	timeout_reached = time_after_eq(jiffies, end_time);
 
-	if (timeout <= 0)
+	if (timeout_reached)
 		show_state(i2c);
 
-	return timeout <= 0 ? I2C_RETRY : 0;
+	return timeout_reached ? I2C_RETRY : 0;
 }
 
 static int i2c_pxa_wait_master(struct pxa_i2c *i2c)
--- a/drivers/i2c/busses/i2c-s3c2410.c
+++ b/drivers/i2c/busses/i2c-s3c2410.c
@@ -465,9 +465,10 @@ static irqreturn_t s3c24xx_i2c_irq(int i
 static int s3c24xx_i2c_set_master(struct s3c24xx_i2c *i2c)
 {
 	unsigned long iicstat;
-	int timeout = 400;
+	unsigned long end_time;
 
-	while (timeout-- > 0) {
+	end_time = jiffies + msecs_to_jiffies(400);
+	while (time_before(jiffies, end_time)) {
 		iicstat = readl(i2c->regs + S3C2410_IICSTAT);
 		
 		if (!(iicstat & S3C2410_IICSTAT_BUSBUSY))
--- a/drivers/i2c/busses/i2c-sis5595.c
+++ b/drivers/i2c/busses/i2c-sis5595.c
@@ -225,7 +225,7 @@ static int sis5595_transaction(struct i2
 {
 	int temp;
 	int result = 0;
-	int timeout = 0;
+	unsigned long end_time;
 
 	/* Make sure the SMBus host is ready to start transmitting */
 	temp = sis5595_read(SMB_STS_LO) + (sis5595_read(SMB_STS_HI) << 8);
@@ -245,13 +245,14 @@ static int sis5595_transaction(struct i2
 	sis5595_write(SMB_CTL_LO, sis5595_read(SMB_CTL_LO) | 0x10);
 
 	/* We will always wait for a fraction of a second! */
+	end_time = jiffies + msecs_to_jiffies(MAX_TIMEOUT);
 	do {
 		msleep(1);
 		temp = sis5595_read(SMB_STS_LO);
-	} while (!(temp & 0x40) && (timeout++ < MAX_TIMEOUT));
+	} while (!(temp & 0x40) && time_before(jiffies, end_time));
 
 	/* If the SMBus is still busy, we give up */
-	if (timeout >= MAX_TIMEOUT) {
+	if (time_after_eq(jiffies, end_time)) {
 		dev_dbg(&adap->dev, "SMBus Timeout!\n");
 		result = -1;
 	}
--- a/drivers/i2c/busses/i2c-sis630.c
+++ b/drivers/i2c/busses/i2c-sis630.c
@@ -163,19 +163,21 @@ static int sis630_transaction_start(stru
 
 static int sis630_transaction_wait(struct i2c_adapter *adap, int size)
 {
-	int temp, result = 0, timeout = 0;
+	int temp, result = 0;
+	unsigned long end_time;
 
 	/* We will always wait for a fraction of a second! */
+	end_time = jiffies + msecs_to_jiffies(MAX_TIMEOUT);
 	do {
 		msleep(1);
 		temp = sis630_read(SMB_STS);
 		/* check if block transmitted */
 		if (size == SIS630_BLOCK_DATA && (temp & 0x10))
 			break;
-	} while (!(temp & 0x0e) && (timeout++ < MAX_TIMEOUT));
+	} while (!(temp & 0x0e) && time_before(jiffies, end_time));
 
 	/* If the SMBus is still busy, we give up */
-	if (timeout >= MAX_TIMEOUT) {
+	if (time_after_eq(jiffies, end_time)) {
 		dev_dbg(&adap->dev, "SMBus Timeout!\n");
 		result = -1;
 	}
--- a/drivers/i2c/busses/i2c-sis96x.c
+++ b/drivers/i2c/busses/i2c-sis96x.c
@@ -103,7 +103,7 @@ static int sis96x_transaction(int size)
 {
 	int temp;
 	int result = 0;
-	int timeout = 0;
+	unsigned long end_time;
 
 	dev_dbg(&sis96x_adapter.dev, "SMBus transaction %d\n", size);
 
@@ -136,13 +136,14 @@ static int sis96x_transaction(int size)
 	sis96x_write(SMB_HOST_CNT, 0x10 | (size & 0x07));
 
 	/* We will always wait for a fraction of a second! */
+	end_time = jiffies + msecs_to_jiffies(MAX_TIMEOUT);
 	do {
 		msleep(1);
 		temp = sis96x_read(SMB_STS);
-	} while (!(temp & 0x0e) && (timeout++ < MAX_TIMEOUT));
+	} while (!(temp & 0x0e) && time_before(jiffies, end_time));
 
 	/* If the SMBus is still busy, we give up */
-	if (timeout >= MAX_TIMEOUT) {
+	if (time_after_eq(jiffies, end_time)) {
 		dev_dbg(&sis96x_adapter.dev, "SMBus Timeout! (0x%02x)\n", temp);
 		result = -1;
 	}
--- a/drivers/i2c/busses/i2c-viapro.c
+++ b/drivers/i2c/busses/i2c-viapro.c
@@ -135,7 +135,7 @@ static int vt596_transaction(u8 size)
 {
 	int temp;
 	int result = 0;
-	int timeout = 0;
+	unsigned long end_time;
 
 	vt596_dump_regs("Transaction (pre)", size);
 
@@ -156,13 +156,14 @@ static int vt596_transaction(u8 size)
 	outb_p(0x40 | size, SMBHSTCNT);
 
 	/* We will always wait for a fraction of a second */
+	end_time = jiffies + msecs_to_jiffies(MAX_TIMEOUT);
 	do {
 		msleep(1);
 		temp = inb_p(SMBHSTSTS);
-	} while ((temp & 0x01) && (timeout++ < MAX_TIMEOUT));
+	} while ((temp & 0x01) && time_before(jiffies, end_time));
 
 	/* If the SMBus is still busy, we give up */
-	if (timeout >= MAX_TIMEOUT) {
+	if (time_after_eq(jiffies, end_time)) {
 		result = -1;
 		dev_err(&vt596_adapter.dev, "SMBus timeout!\n");
 	}
